function bonjourService(_args) {

    var bonjourSocket = Titanium.Network.createTCPSocket({
        hostName:"INADDR_ANY",
        port:40401,
        mode:Titanium.Network.READ_WRITE_MODE
    });
    // Searcher for finding other services
    var serviceBrowser = Titanium.Network.createBonjourBrowser({
        serviceType:'_utest._tcp',
        domain:'local.'
    });
    var localService = Titanium.Network.createBonjourService({
        name:'Bonjour: ' + Titanium.Platform.id,
        type:'_utest._tcp',
        domain:'local.'
    });

    bonjourSocket.addEventListener('read', function(e) {
        var remoteSocket = e['from'];
        var dataStr = e['data'].text;
        if (dataStr && dataStr.startsWith('req')) {

            Ti.App.fireEvent('recieve', {text: "Request from " + dataStr});

            bonjourSocket.write('Hello, from ' + Titanium.Platform.id, remoteSocket);
        }
        else {
            Titanium.UI.createAlertDialog({
                title:'Unknown listener message...',
                message:dataStr
            }).show();
        }
    });

    this.start = function() {
        if (!bonjourSocket.isValid) {
            Ti.API.debug("bonjourSocket.listen();");
            bonjourSocket.listen();

            try
            {
                Ti.API.debug("localService.publish();");
                localService.publish(bonjourSocket);
                Ti.API.debug("localService.published");
            }
            catch (e) {
                bonjourSocket.close();
                Titanium.UI.createAlertDialog({
                    title:'Error!',
                    message:e
                }).show();
            }

        }
    }


    this.stop = function() {
        Titanium.API.info('Stopping the bonjour service...');
        localService.stop();
        Titanium.API.info('The bonjour service has stopped.');
        if (bonjourSocket.isValid) {
            Titanium.API.info('close bonjourSocket...');
            bonjourSocket.close();
            Titanium.API.info('bonjourSocket has closed.');
        }
    };

    this.startSearch = function() {
        serviceBrowser.search();
    };

    this.stopSearch = function() {
        serviceBrowser.stopSearch();
    };

    if (_args && _args.updatedEvent) {
        serviceBrowser.addEventListener("updatedservices", _args.updatedEvent);
    }

    return this;
};

module.exports = bonjourService;